import type * as React from 'react';
import type { HIERARCHY, SHAPE, COLOR, PLACEMENT, ROLE } from './constants';
import type { Override } from '../helpers/overrides';
export type Hierarchy = (typeof HIERARCHY)[keyof typeof HIERARCHY];
export type Shape = (typeof SHAPE)[keyof typeof SHAPE];
export type Color = (typeof COLOR)[keyof typeof COLOR];
export type Placement = (typeof PLACEMENT)[keyof typeof PLACEMENT];
export type Role = (typeof ROLE)[keyof typeof ROLE];
export type BadgeOverrides = {
    Root?: Override;
    Positioner?: Override;
    Badge?: Override;
};
export type BadgeProps = {
    content: React.ReactNode;
    hierarchy?: Hierarchy;
    shape?: Shape;
    color?: Color;
    placement?: Placement;
    hidden?: boolean;
    horizontalOffset?: string;
    verticalOffset?: string;
    overrides?: BadgeOverrides;
    children?: React.ReactNode;
};
export type NotificationCircleProps = {
    content: React.ReactNode;
    color?: Color;
    placement?: Placement;
    hidden?: boolean;
    horizontalOffset?: string;
    verticalOffset?: string;
    overrides?: BadgeOverrides;
    children?: React.ReactNode;
};
export type HintDotProps = {
    color?: Color;
    hidden?: boolean;
    horizontalOffset?: string;
    verticalOffset?: string;
    overrides?: BadgeOverrides;
    children?: React.ReactNode;
};
