/// <reference types="react" />
import type { Override } from '../helpers/overrides';
export type NavItemOverrides = {
    Title?: Override;
    Selector?: Override;
    Panel?: Override;
};
export type BottomNavigationOverrides = {
    Root?: Override;
    SelectorList?: Override;
    OverflowPanel?: Override;
    OverflowPanelList?: Override;
    OverflowTitle?: Override;
    OverflowSelector?: Override;
};
export type Icon = React.ComponentType<{
    size: number;
} & any>;
export type NavItemProps = {
    children?: React.ReactNode;
    title: string;
    icon?: Icon;
    overrides?: NavItemOverrides;
};
export type SelectorProps = {
    title: string;
    icon: Icon;
    isActive: boolean;
    onChange: OnChange;
    overrides: NavItemOverrides;
};
export type PanelProps = {
    isActive: boolean;
    overrides: NavItemOverrides;
    children: React.ReactNode;
};
export type OnChange = (params: {
    activeKey: number;
}) => void;
export interface BottomNavigationProps {
    children?: React.ReactNode;
    activeKey?: number;
    onChange?: OnChange;
    overrides?: BottomNavigationOverrides;
}
