import { DATETIME_OPERATIONS } from './constants';
import type { ColumnOptions, SharedColumnOptions } from './types';
type Options = {
    formatString?: string;
    locale?: any;
} & SharedColumnOptions<Date>;
type DatetimeOperations = typeof DATETIME_OPERATIONS.RANGE_DATETIME | typeof DATETIME_OPERATIONS.RANGE_DATE | typeof DATETIME_OPERATIONS.RANGE_TIME | typeof DATETIME_OPERATIONS.WEEKDAY | typeof DATETIME_OPERATIONS.MONTH | typeof DATETIME_OPERATIONS.QUARTER | typeof DATETIME_OPERATIONS.HALF | typeof DATETIME_OPERATIONS.YEAR;
type FilterParameters = {
    operation: DatetimeOperations;
    range: Date[];
    selection: number[];
    description: string;
    exclude: boolean;
};
type DatetimeColumn = ColumnOptions<Date, FilterParameters>;
declare function DatetimeColumn(options: Options): DatetimeColumn;
export default DatetimeColumn;
