/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import * as React from 'react';
import { StatefulContainer, ACCESSIBILITY_TYPE, PLACEMENT, TRIGGER_TYPE } from '../popover';
import { POPOVER_MARGIN } from '../popover/constants';
import { Helper } from './helper';
export function StatefulHelper(props) {
  const {
    children,
    ...restProps
  } = props;
  return /*#__PURE__*/React.createElement(StatefulContainer, restProps, helperProps => /*#__PURE__*/React.createElement(Helper, helperProps, children));
}
StatefulHelper.defaultProps = {
  accessibilityType: ACCESSIBILITY_TYPE.menu,
  ignoreBoundary: false,
  overrides: {},
  onMouseEnterDelay: 200,
  onMouseLeaveDelay: 200,
  placement: PLACEMENT.bottom,
  showArrow: true,
  triggerType: TRIGGER_TYPE.click,
  dismissOnClickOutside: true,
  dismissOnEsc: true,
  // @ts-ignore
  stateReducer: (_, nextState) => nextState,
  popoverMargin: POPOVER_MARGIN
};