"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calculateFloatingRouteMarkerOffsets = calculateFloatingRouteMarkerOffsets;

var _constants = require("./constants");

var _Object$freeze;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var arrowSize = 8;
var FLOATING_ROUTE_MARKER_OFFSETS = Object.freeze((_Object$freeze = {}, _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.topLeft, function (offset) {
  return "translate(calc(".concat(arrowSize, "px + ").concat(offset, "px), calc(").concat(arrowSize, "px + ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.topRight, function (offset) {
  return "translate(calc(-100% - ".concat(arrowSize, "px - ").concat(offset, "px), calc(").concat(arrowSize, "px + ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.bottomLeft, function (offset) {
  return "translate(calc(".concat(arrowSize, "px + ").concat(offset, "px), calc(-100% - ").concat(arrowSize, "px - ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.bottomRight, function (offset) {
  return "translate(calc(-100% - ".concat(arrowSize, "px - ").concat(offset, "px), calc(-100% - ").concat(arrowSize, "px - ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.topCenter, function (offset) {
  return "translate(-50%, calc(".concat(arrowSize, "px + ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.bottomCenter, function (offset) {
  return "translate(-50%, calc(-100% - ".concat(arrowSize, "px - ").concat(offset, "px))");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.leftCenter, function (offset) {
  return "translate(calc(".concat(arrowSize, "px + ").concat(offset, "px), -50% )");
}), _defineProperty(_Object$freeze, _constants.FLOATING_ROUTE_MARKER_ANCHOR_POSITIONS.rightCenter, function (offset) {
  return "translate(calc(-100% - ".concat(arrowSize, "px - ").concat(offset, "px), -50%)");
}), _Object$freeze));

function calculateFloatingRouteMarkerOffsets(anchorPosition) {
  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  return FLOATING_ROUTE_MARKER_OFFSETS[anchorPosition](offset);
}