import type { SyntheticEvent } from 'react';
import type { Override } from '../helpers/overrides';
import type { BACKGROUND_COLOR_TYPE, IMAGE_LAYOUT, BUTTON_KIND } from './constants';
export type MessageCardOverrides = {
    Root?: Override;
    ContentContainer?: Override;
    HeadingContainer?: Override;
    ParagraphContainer?: Override;
    Button?: Override;
    Image?: Override;
};
export interface MessageCardProps {
    onClick: (a: SyntheticEvent<HTMLButtonElement>) => unknown;
    heading?: React.ReactNode;
    paragraph?: React.ReactNode;
    buttonLabel?: React.ReactNode;
    buttonKind?: keyof typeof BUTTON_KIND;
    backgroundColor?: string;
    backgroundColorType?: keyof typeof BACKGROUND_COLOR_TYPE;
    image?: {
        src: string;
        layout?: keyof typeof IMAGE_LAYOUT;
        backgroundPosition?: string;
        ariaLabel: string;
    };
    overrides?: MessageCardOverrides;
}
