"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isRTL = exports.isIntrinsic = exports.isFixed = exports.getSegmentPanelId = exports.getSegmentId = void 0;

var _constants = require("./constants");

/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
var getSegmentId = function getSegmentId(uid, key) {
  return "segments-".concat(uid, "-segment-").concat(key);
};

exports.getSegmentId = getSegmentId;

var getSegmentPanelId = function getSegmentPanelId(uid, key) {
  return "segments-".concat(uid, "-segmentpanel-").concat(key);
};

exports.getSegmentPanelId = getSegmentPanelId;

var isRTL = function isRTL(direction) {
  return direction === 'rtl';
};

exports.isRTL = isRTL;

var isIntrinsic = function isIntrinsic(fill) {
  return fill === _constants.FILL.intrinsic;
};

exports.isIntrinsic = isIntrinsic;

var isFixed = function isFixed(fill) {
  return fill === _constants.FILL.fixed;
};

exports.isFixed = isFixed;