"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SystemBanner = SystemBanner;

var React = _interopRequireWildcard(require("react"));

var _banner = require("../banner");

var _styledComponents = require("./styled-components");

var _overrides = require("../helpers/overrides");

var _excluded = ["artworkIcon", "primaryAction", "secondaryAction", "overrides"],
    _excluded2 = ["Root", "LeadingContent", "TrailingIconButton", "MessageContent"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function SystemBanner(props) {
  var artworkIcon = props.artworkIcon,
      primaryAction = props.primaryAction,
      secondaryAction = props.secondaryAction,
      _props$overrides = props.overrides,
      overrides = _props$overrides === void 0 ? {} : _props$overrides,
      restProps = _objectWithoutProperties(props, _excluded);

  var Root = overrides.Root,
      LeadingContent = overrides.LeadingContent,
      TrailingIconButton = overrides.TrailingIconButton,
      MessageContent = overrides.MessageContent,
      restOverrides = _objectWithoutProperties(overrides, _excluded2);

  var hasSinglePrimaryAction = (primaryAction === null || primaryAction === void 0 ? void 0 : primaryAction.onClick) && !secondaryAction;
  var hasTwoActions = (primaryAction === null || primaryAction === void 0 ? void 0 : primaryAction.onClick) && (secondaryAction === null || secondaryAction === void 0 ? void 0 : secondaryAction.onClick);
  var hasTrailingIcon = hasSinglePrimaryAction && primaryAction.icon;
  var systemBannerRootOverrides = {
    component: _styledComponents.StyledRoot,
    props: hasSinglePrimaryAction ? {
      $isButton: true,
      $as: 'button',
      onClick: primaryAction.onClick,
      'aria-label': primaryAction.label
    } : {}
  };
  var systemBannerLeadingContentOverrides = {
    component: _styledComponents.StyledLeadingContent
  };
  var styledTrailingIconButtonOverrides = {
    component: _styledComponents.StyledTrailingIconButton,
    props: {
      $as: 'div'
    }
  };
  var systemBannerMessageContentOverrides = {
    component: _styledComponents.StyledMessageContent,
    props: {
      $as: 'button',
      onClick: primaryAction === null || primaryAction === void 0 ? void 0 : primaryAction.onClick,
      'aria-label': primaryAction === null || primaryAction === void 0 ? void 0 : primaryAction.label
    }
  };

  var systemBannerOverrides = _objectSpread({
    Root: (0, _overrides.mergeOverride)(systemBannerRootOverrides, Root || {}),
    LeadingContent: (0, _overrides.mergeOverride)(systemBannerLeadingContentOverrides, LeadingContent || {}),
    TrailingIconButton: hasTrailingIcon ? (0, _overrides.mergeOverride)(styledTrailingIconButtonOverrides, TrailingIconButton || {}) : {},
    MessageContent: hasTwoActions ? (0, _overrides.mergeOverride)(systemBannerMessageContentOverrides, MessageContent || {}) : {}
  }, restOverrides);

  return /*#__PURE__*/React.createElement(_banner.Banner, _extends({
    action: secondaryAction ? _objectSpread({
      onClick: null
    }, secondaryAction) : hasTrailingIcon ? {
      icon: primaryAction.icon,
      onClick: null,
      label: null
    } : null,
    hierarchy: _banner.HIERARCHY.high,
    overrides: systemBannerOverrides
  }, artworkIcon ? {
    artwork: {
      icon: artworkIcon,
      type: _banner.ARTWORK_TYPE.icon
    }
  } : {}, restProps));
}